"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
var core_1 = require('@angular/core');
var scheduler_component_1 = require('./scheduler/scheduler.component');
var AppComponent = (function () {
    function AppComponent() {
        this.title = 'Angular 2 demo';
        //bind properties from the application to the scheduler component
        this.rowHeight = 50;
        this.selectedEvent = '';
        this.events = [];
        this.resources = [];
        this.barMargin = 5;
        this.startDate = new Date(2017, 1, 7, 8);
        this.endDate = new Date(2017, 1, 7, 18);
        this.columns = [
            { type: 'resourceInfo', text: 'Staff', field: 'name', imagePath: 'https://www.bryntum.com/dist/scheduler/examples/_shared/images/users/' },
            {
                text: 'Type',
                field: 'role',
                width: 130,
                editor: {
                    type: 'combo',
                    items: ['Sales', 'Developer', 'Marketing', 'Product manager'],
                    editable: false,
                    pickerWidth: 140
                }
            }
        ];
    }
    AppComponent.prototype.onAddEventClick = function () {
        this.scheduler.addEvent();
    };
    AppComponent.prototype.onRemoveEventClick = function () {
        this.scheduler.removeEvent();
    };
    __decorate([
        core_1.ViewChild(scheduler_component_1.SchedulerComponent), 
        __metadata('design:type', scheduler_component_1.SchedulerComponent)
    ], AppComponent.prototype, "scheduler", void 0);
    AppComponent = __decorate([
        core_1.Component({
            selector: 'my-app',
            template: "\n    <header>\n      <h1><a href=\"..\">Angular 2 demo</a></h1>\n    </header>\n    \n    <div id=\"app\">\n    \n      <div id=\"tools\">\n        <button (click)=\"onAddEventClick()\">Add event</button>\n        <button class=\"red\" (click)=\"onRemoveEventClick()\" [disabled]=\"scheduler.selectedEvent == ''\">Remove event</button>\n        <label class=\"sel-event\">Selected event: <span>{{ scheduler.selectedEvent || 'None' }}</span></label>\n    \n        <div class=\"barmargin\">\n          <label>Barmargin:</label>\n          <input min=\"0\" max=\"15\" type=\"number\" [value]=\"barMargin\" (input)=\"barMargin = $event.target.value-0\">\n        </div>\n      </div>\n    \n      <scheduler\n        #scheduler\n        url=\"data/data.json\"\n        [rowHeight]=50\n        [barMargin]=\"barMargin\"\n        [events]=\"events\"\n        [resources]=\"resources\"\n        [startDate]=\"startDate\"\n        [endDate]=\"endDate\"\n        [columns]=\"columns\"\n      ></scheduler>\n    \n    </div>\n    ",
            directives: [scheduler_component_1.SchedulerComponent]
        }), 
        __metadata('design:paramtypes', [])
    ], AppComponent);
    return AppComponent;
}());
exports.AppComponent = AppComponent;
//# sourceMappingURL=app.component.js.map