"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
var core_1 = require('@angular/core');
var http_1 = require('@angular/http');
require('rxjs/add/operator/map');
var SchedulerComponent = (function () {
    function SchedulerComponent(http) {
        this.http = http;
        this.onEventSelect = new core_1.EventEmitter();
    }
    SchedulerComponent.prototype.ngAfterContentInit = function () {
        var _this = this;
        // parse dates
        var start = new Date(this.startDate), end = new Date(this.endDate);
        this.eventStore = Ext.create('Sch.data.EventStore', {
            model: 'Sch.model.Event',
            proxy: {
                type: 'memory'
            }
        });
        this.resourceStore = Ext.create('Sch.data.ResourceStore');
        // create scheduler
        this.scheduler = Ext.create('Sch.panel.SchedulerGrid', {
            height: 400,
            // input configs (from tag)
            rowHeight: this.rowHeight || 35,
            title: this.title,
            split: this.split,
            viewPreset: this.preset,
            startDate: start,
            endDate: end,
            barMargin: 2,
            renderTo: 'scheduler',
            bodyBorder: false,
            columns: [
                { header: 'Name', sortable: true, width: 160, dataIndex: 'Name' }
            ],
            resourceStore: this.resourceStore,
            eventStore: this.eventStore,
            listeners: {
                eventselect: function (em, eventRecord) {
                    this.onEventSelect.emit(eventRecord);
                },
                scope: this
            }
        });
        // load data
        this.http.get(this.url)
            .map(function (r) { return r.json(); })
            .subscribe(function (data) { return _this.loadData(data); }, function (err) { return console.error(err); });
    };
    /**
     * Consumes json in format { resources: [], events: [] }
     * @param data
     */
    SchedulerComponent.prototype.loadData = function (data) {
        this.resourceStore.loadData(data.resources);
        this.eventStore.proxy.data = data.events;
        this.eventStore.load();
        this.eventCount = this.eventStore.getCount();
    };
    /**
     * Add event to random resource on random day
     */
    SchedulerComponent.prototype.addRandomEvent = function () {
        var eventStore = this.eventStore, startDay = (Math.floor(Math.random() * 7) + 5);
        eventStore.add({
            ResourceId: 'r' + (Math.floor(Math.random() * 6) + 1),
            Name: 'New event ' + eventStore.getCount(),
            StartDate: '2017-09-' + Ext.String.leftPad(startDay, 2, '0'),
            EndDate: '2017-09-' + Ext.String.leftPad((startDay + 1), 2, '0')
        });
        this.eventCount = eventStore.getCount();
    };
    __decorate([
        core_1.Input(), 
        __metadata('design:type', String)
    ], SchedulerComponent.prototype, "title", void 0);
    __decorate([
        core_1.Input(), 
        __metadata('design:type', Number)
    ], SchedulerComponent.prototype, "rowHeight", void 0);
    __decorate([
        core_1.Input(), 
        __metadata('design:type', Boolean)
    ], SchedulerComponent.prototype, "split", void 0);
    __decorate([
        core_1.Input(), 
        __metadata('design:type', String)
    ], SchedulerComponent.prototype, "preset", void 0);
    __decorate([
        core_1.Input(), 
        __metadata('design:type', String)
    ], SchedulerComponent.prototype, "url", void 0);
    __decorate([
        core_1.Input(), 
        __metadata('design:type', String)
    ], SchedulerComponent.prototype, "startDate", void 0);
    __decorate([
        core_1.Input(), 
        __metadata('design:type', String)
    ], SchedulerComponent.prototype, "endDate", void 0);
    __decorate([
        core_1.Output(), 
        __metadata('design:type', Object)
    ], SchedulerComponent.prototype, "onEventSelect", void 0);
    __decorate([
        core_1.Output(), 
        __metadata('design:type', Number)
    ], SchedulerComponent.prototype, "eventCount", void 0);
    SchedulerComponent = __decorate([
        core_1.Component({
            selector: 'scheduler',
            template: '<div id="scheduler"></div>',
            providers: [http_1.HTTP_PROVIDERS]
        }), 
        __metadata('design:paramtypes', [http_1.Http])
    ], SchedulerComponent);
    return SchedulerComponent;
}());
exports.SchedulerComponent = SchedulerComponent;
//# sourceMappingURL=scheduler.component.js.map