import {Component, ViewChild} from '@angular/core';
import {NgModel} from '@angular/forms';
import {SchedulerComponent} from "./scheduler/scheduler.component";
import {HttpClient} from '@angular/common/http';

@Component({
  selector: 'app-root',
  templateUrl: './app.component.html',
  styleUrls: ['./app.component.scss']
})
export class AppComponent {

  @ViewChild(SchedulerComponent) scheduler: SchedulerComponent;

  //bind properties from the application to the scheduler component
  rowHeight = 50;
  selectedEvent = '';
  events = [];
  resources = [];
  timeRanges = true;
  barMargin = 5;
  startDate = new Date(2017, 1, 7, 8);
  endDate = new Date(2017, 1, 7, 18);
  columns = [
    { type: 'resourceInfo', text: 'Staff', field: 'name', imagePath : 'https://www.bryntum.com/dist/scheduler/examples/_shared/images/users/' },
    {
      text: 'Type',
      field: 'role',
      width: 130,
      editor: {
        type: 'combo',
        items: ['Sales', 'Developer', 'Marketing', 'Product manager'],
        editable: false,
        pickerWidth: 140
      }
    }
  ];

  constructor(private http: HttpClient) {
    this.getData();
  }

  //fetch data for the scheduler
  getData() {

    let me = this;

    me.http.get('./assets/data/data.json').subscribe(data => {
      me.resources = data['resources'].rows;
      me.events = data['events'].rows;
      me.timeRanges = data['timeRanges'].rows;
    });
  }

  onSchedulerEvents() {
    //catch scheduler event here
  }

  //add event button click handled here
  onAddEventClick() {
    this.scheduler.addEvent();
  }

  //remove event button click handled here
  onRemoveEventClick() {
    this.scheduler.removeEvent();
  }

}
