/* SystemJS module definition */
declare var module: NodeModule;

interface NodeModule {
  id: string;
}

declare module "grid" {
  export class Grid {
    selectedRecord: Model;
    store: any;

    constructor(config : object)
  }

  export class Model {
    static fields       : any[];

    id                  : string|number;
    internalId          : number;

    parent : Model;
    children            : Model[];

    stores              : any[];

    constructor(...args : any[])

    get (fieldName)

    addChild(childRecord)

    insertChild(index, childRecord)

    removeChild(childRecord)

    remove()

    set (fieldName, fieldValue)

    joinStore(store)

    traverse (fn : (model : Model) => any, skipSelf? : boolean)
  }
}
